import { Module } from '@nestjs/common';
import { PassportModule } from '@nestjs/passport';
import { TypeOrmModule } from '@nestjs/typeorm';
import { EquipoTipoEntradaController } from './equipo-tipo-entrada.controller';
import { EquipoTipoEntradaService } from './equipo-tipo-entrada.service';
import { EquipoTipoEntrada } from '../equipo-tipo-entrada/entity/equipo-tipo-entrada.entity';
import { InformacionEquipoTipoEntradaView } from './entity/views/informacion-equipo-tipo-entrada.view';
import { EquipoModule } from '../equipo/equipo.module';
import { InstitucionTipoEntradaModule } from '../institucion-tipo-entrada/institucion-tipo-entrada.module';
import { ValidarUsuarioModule } from '../validar-usuario/validar-usuario.module';

@Module({
  imports: [
    EquipoModule,
    InstitucionTipoEntradaModule,
    PassportModule.register({ defaultStrategy: 'jwt' }),
    TypeOrmModule.forFeature([
      EquipoTipoEntrada,
      InformacionEquipoTipoEntradaView,
    ]),
    ValidarUsuarioModule,
  ],
  controllers: [EquipoTipoEntradaController],
  providers: [EquipoTipoEntradaService],
  exports: [EquipoTipoEntradaService],
})
export class EquipoTipoEntradaModule {}
