import { DataSource, ViewEntity, ViewColumn } from 'typeorm';
import { Carrito } from '../../../carrito/entity/carrito.entity';
import { Equipo } from '../equipo.entity';
import { Institucion } from '../../../institucion/entity/institucion.entity';
import { Modulo } from '../../../modulo/entity/modulo.entity';
import { EquipoPrograma } from '../../../equipo-programa/entity/equipo-programa.entity';
import { EquipoTipoEntrada } from '../../../equipo-tipo-entrada/entity/equipo-tipo-entrada.entity';
import { Programa } from '../../../institucion-programa/entity/programa.entity';
import { TipoEntrada } from '../../../institucion-tipo-entrada/entity/tipo-entrada.entity';

@ViewEntity({
  expression: (dataSource: DataSource) =>
    dataSource
      .createQueryBuilder()
      .select('e.id_equipo', 'id_equipo')
      .addSelect('e.equipo', 'equipo')
      .addSelect('e.id_carrito', 'id_carrito')
      .addSelect('e.id_status', 'id_status')
      .addSelect('e.numero_inventario', 'numero_inventario')
      .addSelect('e.prestado', 'prestado')
      .addSelect('c.activo', 'activo_carrito')
      .addSelect('c.carrito', 'carrito')
      .addSelect('c.id_modulo', 'id_modulo')
      .addSelect('c.id_tipo_carrito', 'id_tipo_carrito')
      .addSelect('m.activo', 'activo_modulo')
      .addSelect('m.id_institucion', 'id_institucion')
      .addSelect('i.activo', 'activo_institucion')
      // .addSelect('p.id_programa')
      // .addSelect('p.id_programa')
      // .addSelect('te.id_tipo_entrada')
      // .addSelect('tc.id_tipo_carrito')
      .from(Equipo, 'e')
      .innerJoin(Carrito, 'c', 'c.id_carrito = e.id_carrito')
      .innerJoin(Modulo, 'm', 'm.id_modulo = c.id_modulo')
      .innerJoin(Institucion, 'i', 'i.id_institucion = m.id_institucion'),
  // .innerJoin(EquipoPrograma, 'ps', 'ps.id_equipo = e.id_equipo')
  // .innerJoin(EquipoTipoEntrada, 'tes', 'tes.id_equipo = e.id_equipo')
  // .innerJoin(TipoEntrada, 'te', 'te.id_tipo_entrada = c.id_tipo_entrada')
  // .innerJoin(Programa, 'p', 'p.id_programa = e.id_programa')
})
export class InformacionEquipoView {
  @ViewColumn()
  id_equipo: number;

  @ViewColumn()
  activo_carrito: boolean;

  @ViewColumn()
  activo_institucion: boolean;

  @ViewColumn()
  activo_modulo: boolean;

  @ViewColumn()
  carrito: string;

  @ViewColumn()
  equipo: string;

  @ViewColumn()
  id_modulo: number;

  @ViewColumn()
  id_carrito: number;

  @ViewColumn()
  id_institucion: number;

  @ViewColumn()
  id_tipo_carrito: number;

  @ViewColumn()
  id_status: number;

  @ViewColumn()
  numero_inventario: string;

  @ViewColumn()
  prestado: boolean;
}
